#include <lib.h>
#include <mem.h>
#include <init.h>

char *stamp = "\
Khaos - 0.0 build 003\n\
Copyright 2009 Nick Johnson\n\n";

typedef void (*init_t)(void);
init_t init_list[] = {
init_detect,
init_mem,
NULL
};

int init(void *mboot_ptr, u32int mboot_magic) {
	u32int i;
	cleark();
	printk(stamp);

	if (mboot_magic != 0x2BADB002) {
		printk("Kernel panic: Bootloader is not multiboot compliant\n");
		for(;;);
	}
	else mboot = mboot_ptr;

	printk("Booting Khaos\n");
	for (i = 0; init_list[i]; i++) init_list[i]();
	printk("Khaos booted\n\n");

	panic("loss of purpose");

	return 0;
}
