#include <lib.h>
#include <mem.h>
#include <init.h>

u32int memsize = 0x400000; // Assume at least 4MB memory

void init_mem() {
	u32int i;

	colork(0xC);

	map_alloc(&kmap);

	printk("Frame allocator");
	fpool = pool_new(memsize >> 12);
	cursek(36, -1);
	printk("done\n");

	printk("Kernel heap allocator");
	// Make page tables for allocator
	i = 0xF8400000;
	while (i) {
		page_touch(&kmap, i);
		i += 0x400000;
	}
	ppool = pool_new(0x7C00000 >> 12);
	cursek(36, -1);
	printk("done\n");

	printk("Kernel address space");
	// Create kernel map and identity map kernel stuff
	i = 0xF8000000;
	extern u32int end;
	while (i <= proto_base || i <= (u32int) &end) {
		page_touch(&kmap, i);
		page_t new_page = page_fmt(frame_new(), PF_PRES | PF_RW);
		page_set(&kmap, i, new_page);
		i += 0x1000;
	}
	cursek(36, -1);
	printk("done\n");


	printk("Full paging");
	// Switch to new kernel page directory
	kmap.pdir[0] = kmap.pdir[0xF8000000 >> 22];
	redo_paging(phys_of(&kmap, kmap.pdir));
	kmap.virt[0] = NULL;
	kmap.pdir[0] = 0x00000000;
	mem_setup = 1;
	map_load(&kmap);
	cursek(36, -1);
	printk("done\n");

	colork(0xF);

}
