#include <lib.h>
#include <mem.h>

map_t *map_alloc(map_t *map) {
	map->pdir = kmalloc(0x1000);
	map->virt = kmalloc(0x1000);
	memclr((u32int*) map->pdir, 0x1000);
	memclr((u32int*) map->virt, 0x1000);
	return map;
}

map_t *map_free(map_t *map) {
	kfree(map->pdir);
	kfree(map->virt);
	return map;
}

map_t *map_clean(map_t *map, map_t *skip) {
	u32int i, j;

	for (i = 0; i < 1024; i++) if (map->virt[i] && !skip->virt[i]) {
		for (j = 0; j < 1024; j++) {
			frame_free(page_ufmt(map->virt[i][j]));
			map->virt[i][j] = 0x00000000;
		}
		kfree(map->virt[i]);
		map->pdir[i] = 0x00000000;
	}

	return map;
}			

map_t *map_clone(map_t *dest, map_t *src, map_t *link);

map_t *map_load(map_t *map) {
	asm volatile ("mov %0, %%cr3" :: "r" (phys_of(&kmap, map->pdir)));
	return map;
}
