#include <lib.h>
#include <mem.h>

char mem_setup = 0;

page_t page_touch(map_t *map, u32int page) {
	if (map->virt[page >> 22]) return map->virt[page >> 22][(page >> 12) % 1024];
	map->virt[page >> 22] = kmalloc(0x1000);
	map->pdir[page >> 22] = phys_of(&kmap, (void*) map->virt[page >> 22]) | PF_PRES | PF_RW | PF_USER;
	memclr(map->virt[page >> 22], 0x1000);
	return 0x00000000;
}

page_t page_set(map_t *map, u32int page, page_t value) {
	if (!map->virt[page >> 22]) page_touch(map, page);
	return (map->virt[page >> 22][(page >> 12) % 1024] = value);
}

page_t page_get(map_t *map, u32int page) {
	if (!map->virt[page >> 22]) return 0x00000000;
	return map->virt[page >> 22][(page >> 12) % 1024];
}

u32int phys_of(map_t *map, void *addr) {
	if (!mem_setup) return (u32int) addr & ~0xF8000000;
	if (!map->virt[(u32int) addr >> 22]) return 0x00000000;
	u32int temp = map->virt[(u32int) addr >> 22][((u32int) addr >> 12) % 1024];
	temp &= 0xFFFFF000;
	temp |= ((u32int) addr & 0xFFF);
	return temp;
}
